From 40b79a03b3c4caff8f63d438cb2a3e687a7cd3f4 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 22:46:22 +0000
Subject: [PATCH 1290/2232] Merge pull request #424 from dtolnay/prefixes


Implement CFG.exported_header_prefixes
---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 8ee96cb..21e4ea8 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -238,15 +238,23 @@ fn make_this_crate(prj: &Project) -> Result<Crate> {
     }
 
     for krate in deps::direct_dependencies() {
-        let links_attribute = match krate.links {
-            Some(links) => links,
-            None => continue,
+        let is_link_exported = || match &krate.links {
+            None => false,
+            Some(links_attribute) => CFG
+                .exported_header_links
+                .iter()
+                .any(|exported| links_attribute == *exported),
         };
 
-        let exported = CFG
-            .exported_header_links
-            .iter()
-            .any(|exported| links_attribute == *exported);
+        let is_prefix_exported = || match &krate.include_prefix {
+            None => false,
+            Some(include_prefix) => CFG
+                .exported_header_prefixes
+                .iter()
+                .any(|exported| include_prefix.starts_with(exported)),
+        };
+
+        let exported = is_link_exported() || is_prefix_exported();
 
         this_crate
             .header_dirs

